﻿#language: ru

@purchase

Функционал: 009. Purchase. Корректировка поступлений

Сценарий: 009.1. Purchase. Причины корректировок поступления
	
	Дано Я подключаюсь под "Формирование поступлений"
	Дано я устанавливаю текущему сеансу заголовок приложения "08.009. Закупки"
	Дано я удаляю объекты "Справочники.к2ПричиныКорректировокДокументов" без контроля ссылок
	И Я создаю причину возврата "Изменилась цена поставщика" с комментарием "Изменилась цена товара поставщика" для закупок
	И Я создаю причину возврата "Изменилось количество в поступлении" с комментарием "Изменилось количество товара в поступлении" для закупок
	И Я создаю причину возврата "Изменились цена и количество" с комментарием "Изменились цена и количество товара в поступлении" для закупок

Сценарий: 009.2. Purchase. Корректировка поступления

	Дано я удаляю объекты "Документы.КорректировкаПоступления" без контроля ссылок
	И В командном интерфейсе я выбираю 'Закупки' 'Поступления товаров и услуг'
	Тогда открылось окно 'Поступления товаров и услуг'
	И в таблице "Список" я перехожу к строке:
		| 'Организация' | 'Плановая дата поставки' | 'Подразделение'                 | 'Поставщик'       | 'Сумма'         |
		| 'Организация' | '21.07.2019'             | 'Подразделение приемки заказов' | 'Ашан(поставщик)' | '1 000,00, RUB' |
	И я нажимаю на кнопку 'Сформировать счет-фактуру'
	Тогда в логе сообщений TestClient есть строка по шаблону "Сформирован документ Счет-фактура полученный *"
	И я нажимаю на кнопку 'Корректировка поступления товаров'
	Тогда открылось окно 'Корректировка поступления товаров (создание)'
	И из выпадающего списка "Вид корректировки" я выбираю точное значение 'Исправление ошибок'
	И элемент формы с именем "ВидКорректировки" стал равен 'Исправление ошибок'
	И элемент формы с именем "Организация" стал равен 'Организация'
	И элемент формы с именем "Подразделение" стал равен 'Подразделение приемки заказов'
	И элемент формы с именем "Холдинг" стал равен 'Холдинг-компания'
	И элемент формы с именем "Поставщик" стал равен 'Ашан(поставщик)'
	И элемент формы с именем "Соглашение" стал равен 'Соглашение для Ашана на дату заказа (поставщик)'
	И элемент формы с именем "Склад" стал равен 'Склад(ячейки и контроль)'
	И элемент формы с именем "Ячейка" стал равен '1020011'
	И элемент формы с именем "МоментОпределенияЦены" стал равен 'На дату заказа'
	И элемент формы с именем "Налогообложение" стал равен 'Облагается (с НДС)'
	И элемент формы с именем "ВидЦен" стал равен 'Ашан'
	И элемент формы с именем "ЦенаВключаетНДС" стал равен 'Да'
	И я перехожу к закладке "Товары"
	И в таблице "Товары" я перехожу к строке:
		| 'Номенклатура'   |
		| 'Сыр Адыгейский' |
	И в таблице "Товары" в поле с именем 'ТоварыКоличествоУпаковок' я ввожу текст '10,000'
	И в таблице "Товары" я завершаю редактирование строки
	И в таблице "Товары" я перехожу к строке:
		| 'Номенклатура'    |
		| 'Сыр Костромской' |
	И в таблице "Товары" в поле 'Цена, RUB' я ввожу текст '100,00'
	И в таблице "Товары" я завершаю редактирование строки
	И я перехожу к закладке "Расхождения"
	И в таблице "Расхождения" я нажимаю на кнопку 'Заполнить расхождения'
	Тогда таблица "Расхождения" стала равной:
		| 'Количество' | 'Номенклатура'    | 'Ед.' | 'Характеристика'   | 'Серия'                        | 'В ед. хранения' | 'Цена'   | 'Цена с учетом скидок' | '% НДС' | 'Сумма'    | 'Сумма НДС' | 'Всего'    |
		| '5,000'      | 'Сыр Адыгейский'  | 'кг'  | '<Без маркировки>' | '000001 до 27.10.2020 0:00:00' | '5,000, кг'      | '100,00' | '100,00'               | '20%'   | '500,00'   | '83,34'     | '500,00'   |
		| '10,000'     | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | '000001 до 27.10.2020 0:00:00' | '10,000, кг'     | '100,00' | '100,00'               | '18%'   | '1 000,00' | '152,54'    | '1 000,00' |
		| '-10,000'    | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | '000001 до 27.10.2020 0:00:00' | '-10,000, кг'    | '50,00'  | '50,00'                | '18%'   | '-500,00'  | '-76,27'    | '-500,00'  |
	И в таблице "Расхождения" я перехожу к строке:
		| '% НДС' | 'В ед. хранения' | 'Всего'  | 'Ед.' | 'Количество' | 'Номенклатура'   | 'Серия'                        | 'Сумма'  | 'Сумма НДС' | 'Характеристика'   |
		| '20%'   | '5,000, кг'      | '500,00' | 'кг'  | '5,000'      | 'Сыр Адыгейский' | '000001 до 27.10.2020 0:00:00' | '500,00' | '83,34'     | '<Без маркировки>' |
	И в таблице "Расхождения" из выпадающего списка "Причина" я выбираю по строке 'Изменилось количество в поступлении'
	И в таблице "Расхождения" я завершаю редактирование строки
	И в таблице "Расхождения" я перехожу к строке:
		| 'Количество' | 'Номенклатура'    | 'Ед.' | 'Характеристика'   | 'Серия'                        | 'В ед. хранения' | 'Цена'   | 'Цена с учетом скидок' | '% НДС' | 'Сумма'    | 'Сумма НДС' | 'Всего'    |
		| '10,000'     | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | '000001 до 27.10.2020 0:00:00' | '10,000, кг'     | '100,00' | '100,00'               | '18%'   | '1 000,00' | '152,54'    | '1 000,00' |
	И в таблице "Расхождения" из выпадающего списка "Причина" я выбираю по строке 'Изменилась цена поставщика'
	И в таблице "Расхождения" я завершаю редактирование строки
	И в таблице "Расхождения" я перехожу к строке:
		| 'Количество' | 'Номенклатура'    | 'Ед.' | 'Характеристика'   | 'Серия'                        | 'В ед. хранения' | 'Цена'   | 'Цена с учетом скидок' | '% НДС' | 'Сумма'    | 'Сумма НДС' | 'Всего'    |
		| '-10,000'    | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | '000001 до 27.10.2020 0:00:00' | '-10,000, кг'    | '50,00'  | '50,00'                | '18%'   | '-500,00'  | '-76,27'    | '-500,00'  |
	И в таблице "Расхождения" из выпадающего списка "Причина" я выбираю по строке 'Изменилась цена поставщика'
	И в таблице "Расхождения" я завершаю редактирование строки
	И в поле 'Комментарий' я ввожу текст 'Корректировка поступления товаров'
	И я нажимаю на кнопку 'Провести'
	Тогда открылось окно 'Корректировка поступления товаров * от *'
	И я перехожу к закладке "Основное"
	И я нажимаю на кнопку 'Оформить счет-фактуру'
	Тогда открылось окно 'Счет-фактура полученный (создание)'
	И элемент формы с именем "ПоСчетуФактуре" стал равен 'Да'
	И элемент формы с именем "Организация" стал равен 'Организация'
	И элемент формы с именем "Поставщик" стал равен 'Ашан(поставщик)'
	И я нажимаю на кнопку 'Провести'
	И я нажимаю на кнопку 'Счет-фактура полученный'
	Тогда открылось окно 'Счет-фактура полученный (создание)'
	И элемент формы с именем "ПоСчетуФактуре" стал равен 'Да'
	И элемент формы с именем "Организация" стал равен 'Организация'
	И элемент формы с именем "Поставщик" стал равен 'Ашан(поставщик)'
	И я нажимаю на кнопку 'Провести и закрыть'
	Тогда открылось окно 'Счет-фактура полученный * от *'
	И я нажимаю на кнопку 'Провести и закрыть'
	И я жду закрытия окна 'Счет-фактура полученный * от *' в течение 20 секунд
	Тогда открылось окно 'Корректировка поступления товаров * от *'
	И я нажимаю на кнопку 'Провести и закрыть'
	И я жду закрытия окна 'Корректировка поступления товаров * от *' в течение 20 секунд
	Тогда открылось окно 'Поступления товаров и услуг'
	И я закрываю окно 'Поступления товаров и услуг'

Сценарий: 009.3. Purchase. Корректировка корректировки поступления

	И В командном интерфейсе я выбираю 'Закупки' 'Корректировки поступлений товаров'
	Тогда открылось окно 'Корректировки поступлений товаров'
	И в таблице "Список" я перехожу к строке:
		| 'Комментарий'                       | 'Организация' | 'Подразделение'                 | 'Поставщик'       | 'Склад'                    | 'Соглашение'                      | 'Сумма'         |
		| 'Корректировка поступления товаров' | 'Организация' | 'Подразделение приемки заказов' | 'Ашан(поставщик)' | 'Склад(ячейки и контроль)' | 'Соглашение для Ашана на дату заказа (поставщик)' | '2 000,00, RUB' |
	И я нажимаю на кнопку 'Сформировать счет-фактуру'
	Тогда в логе сообщений TestClient есть строка по шаблону "Сформирован документ Счет-фактура полученный *"
	И я нажимаю на кнопку 'Корректировка поступления товаров'
	Тогда открылось окно 'Корректировка поступления товаров (создание)'
	И из выпадающего списка "Вид корректировки" я выбираю точное значение 'Корректировка по соглашению сторон'
	И элемент формы с именем "ВидКорректировки" стал равен 'Корректировка по соглашению сторон'
	И элемент формы с именем "Организация" стал равен 'Организация'
	И элемент формы с именем "Подразделение" стал равен 'Подразделение приемки заказов'
	И элемент формы с именем "Холдинг" стал равен 'Холдинг-компания'
	И элемент формы с именем "Поставщик" стал равен 'Ашан(поставщик)'
	И элемент формы с именем "Соглашение" стал равен 'Соглашение для Ашана на дату заказа (поставщик)'
	И элемент формы с именем "Склад" стал равен 'Склад(ячейки и контроль)'
	И элемент формы с именем "Ячейка" стал равен '1020011'
	И элемент формы с именем "МоментОпределенияЦены" стал равен 'На дату заказа'
	И элемент формы с именем "Налогообложение" стал равен 'Облагается (с НДС)'
	И элемент формы с именем "ВидЦен" стал равен 'Ашан'
	И элемент формы с именем "ЦенаВключаетНДС" стал равен 'Да'
	И я перехожу к закладке "Товары"
	Тогда таблица "Товары" стала равной:
		| 'Количество' | 'Номенклатура'    | 'Ед.' | 'Характеристика'   | 'Сумма, RUB' | 'Серия'                        | 'В ед. хранения' | 'Цена, RUB' | 'Цена с учетом скидок' | '% НДС' | 'НДС, RUB' | 'Всего, RUB' | 'Вес, кг' |
		| '10,000'     | 'Сыр Адыгейский'  | 'кг'  | '<Без маркировки>' | '1 000,00'   | '000001 до 27.10.2020 0:00:00' | '10,000, кг'     | '100,00'    | '100,00'               | '20%'   | '166,67'   | '1 000,00'   | '10'      |
		| '10,000'     | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | '1 000,00'   | '000001 до 27.10.2020 0:00:00' | '10,000, кг'     | '100,00'    | '100,00'               | '18%'   | '152,54'   | '1 000,00'   | '10'      |
	И в таблице "Товары" я перехожу к строке:
		| '% НДС' | 'В ед. хранения' | 'Вес, кг' | 'Всего, RUB' | 'Ед.' | 'Количество' | 'Номенклатура'   | 'Серия'                        | 'НДС, RUB' | 'Сумма, RUB' | 'Характеристика'   | 'Цена с учетом скидок' | 'Цена, RUB' |
		| '20%'   | '10,000, кг'     | '10'      | '1 000,00'   | 'кг'  | '10,000'     | 'Сыр Адыгейский' | '000001 до 27.10.2020 0:00:00' | '166,67'   | '1 000,00'   | '<Без маркировки>' | '100,00'               | '100,00'    |
	И в таблице "Товары" я нажимаю на кнопку 'Разбить строку'
	Тогда открылось окно 'Введите количество товара в новой строке'
	И в поле 'InputFld' я ввожу текст '3,000'
	И я нажимаю на кнопку 'OK'
	Тогда открылось окно 'Корректировка поступления товаров (создание) *'
	Тогда таблица "Товары" стала равной:
		| 'Количество' | 'Номенклатура'    | 'Ед.' | 'Характеристика'   | 'Сумма, RUB' | 'Серия'                        | 'В ед. хранения' | 'Цена, RUB' | 'Цена с учетом скидок' | '% НДС' | 'НДС, RUB' | 'Всего, RUB' | 'Вес, кг' |
		| '7,000'      | 'Сыр Адыгейский'  | 'кг'  | '<Без маркировки>' | '700,00'     | '000001 до 27.10.2020 0:00:00' | '7,000, кг'      | '100,00'    | '100,00'               | '20%'   | '116,67'   | '700,00'     | '7'       |
		| '3,000'      | 'Сыр Адыгейский'  | 'кг'  | '<Без маркировки>' | '300,00'     | '000001 до 27.10.2020 0:00:00' | '3,000, кг'      | '100,00'    | '100,00'               | '20%'   | '50,00'    | '300,00'     | '3'       |
		| '10,000'     | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | '1 000,00'   | '000001 до 27.10.2020 0:00:00' | '10,000, кг'     | '100,00'    | '100,00'               | '18%'   | '152,54'   | '1 000,00'   | '10'      |
	И в таблице "Товары" я перехожу к строке:
		| 'Номенклатура'    |
		| 'Сыр Костромской' |
	И в таблице "Товары" в поле с именем 'ТоварыКоличествоУпаковок' я ввожу текст '11,000'
	И в таблице "Товары" в поле 'Цена, RUB' я ввожу текст '150,00'
	И в таблице "Товары" я завершаю редактирование строки
	И в таблице "Товары" я нажимаю на кнопку с именем 'ТоварыДобавить'
	И в таблице "Товары" из выпадающего списка с именем "ТоварыНоменклатура" я выбираю по строке 'Сыр Адыгейский'
	И в таблице "Товары" из выпадающего списка с именем "ТоварыХарактеристика" я выбираю по строке '<Без маркировки>'
	И в таблице "Товары" из выпадающего списка с именем "ТоварыСерия" я выбираю по строке '000001 до 27.10.2020 0:00:00'
	И в таблице "Товары" в поле с именем 'ТоварыКоличествоУпаковок' я ввожу текст '5,000'
	И в таблице "Товары" я завершаю редактирование строки
	Тогда таблица "Товары" стала равной:
		| 'Количество' | 'Номенклатура'    | 'Ед.' | 'Характеристика'   | 'Сумма, RUB' | 'Серия'                        | 'В ед. хранения' | 'Цена, RUB' | 'Цена с учетом скидок' | '% НДС' | 'НДС, RUB' | 'Всего, RUB' | 'Вес, кг' |
		| '7,000'      | 'Сыр Адыгейский'  | 'кг'  | '<Без маркировки>' | '700,00'     | '000001 до 27.10.2020 0:00:00' | '7,000, кг'      | '100,00'    | '100,00'               | '20%'   | '116,67'   | '700,00'     | '7'       |
		| '3,000'      | 'Сыр Адыгейский'  | 'кг'  | '<Без маркировки>' | '300,00'     | '000001 до 27.10.2020 0:00:00' | '3,000, кг'      | '100,00'    | '100,00'               | '20%'   | '50,00'    | '300,00'     | '3'       |
		| '11,000'     | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | '1 650,00'   | '000001 до 27.10.2020 0:00:00' | '11,000, кг'     | '150,00'    | '150,00'               | '18%'   | '251,69'   | '1 650,00'   | '11'      |
		| '5,000'      | 'Сыр Адыгейский'  | 'кг'  | '<Без маркировки>' | '500,00'     | '000001 до 27.10.2020 0:00:00' | '5,000, кг'      | '100,00'    | '100,00'               | '20%'   | '83,33'    | '500,00'     | '5'       |
	И я перехожу к закладке "Расхождения"
	И в таблице "Расхождения" я нажимаю на кнопку 'Заполнить расхождения'
	Тогда таблица "Расхождения" стала равной:
		| 'N' | 'Количество' | 'Номенклатура'    | 'Ед.' | 'Характеристика'   | 'Причина' | 'Серия'                        | 'В ед. хранения' | 'Цена'   | 'Цена с учетом скидок' | '% НДС' | 'Сумма'     | 'Сумма НДС' | 'Всего'     |
		| '1' | '5,000'      | 'Сыр Адыгейский'  | 'кг'  | '<Без маркировки>' | ''        | '000001 до 27.10.2020 0:00:00' | '5,000, кг'      | '100,00' | '100,00'               | '20%'   | '500,00'    | '83,33'     | '500,00'    |
		| '2' | '11,000'     | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | ''        | '000001 до 27.10.2020 0:00:00' | '11,000, кг'     | '150,00' | '150,00'               | '18%'   | '1 650,00'  | '251,69'    | '1 650,00'  |
		| '3' | '-10,000'    | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | ''        | '000001 до 27.10.2020 0:00:00' | '-10,000, кг'    | '100,00' | '100,00'               | '18%'   | '-1 000,00' | '-152,54'   | '-1 000,00' |
	И в таблице "Расхождения" я перехожу к строке:
		| 'N' | 'Количество' | 'Номенклатура'    | 'Ед.' | 'Характеристика'   | 'Причина' | 'Серия'                        | 'В ед. хранения' | 'Цена'   | 'Цена с учетом скидок' | '% НДС' | 'Сумма'     | 'Сумма НДС' | 'Всего'     |
		| '1' | '5,000'      | 'Сыр Адыгейский'  | 'кг'  | '<Без маркировки>' | ''        | '000001 до 27.10.2020 0:00:00' | '5,000, кг'      | '100,00' | '100,00'               | '20%'   | '500,00'    | '83,33'     | '500,00'    |
	И в таблице "Расхождения" из выпадающего списка "Причина" я выбираю по строке 'Изменилось количество в поступлении'
	И в таблице "Расхождения" я завершаю редактирование строки
	И в таблице "Расхождения" я перехожу к строке:
		| 'N' | 'Количество' | 'Номенклатура'    | 'Ед.' | 'Характеристика'   | 'Причина' | 'Серия'                        | 'В ед. хранения' | 'Цена'   | 'Цена с учетом скидок' | '% НДС' | 'Сумма'     | 'Сумма НДС' | 'Всего'     |
		| '2' | '11,000'     | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | ''        | '000001 до 27.10.2020 0:00:00' | '11,000, кг'     | '150,00' | '150,00'               | '18%'   | '1 650,00'  | '251,69'    | '1 650,00'  |
	И в таблице "Расхождения" из выпадающего списка "Причина" я выбираю по строке 'Изменились цена и количество в поступлен'
	И в таблице "Расхождения" я завершаю редактирование строки
	И в таблице "Расхождения" я перехожу к строке:
		| 'N' | 'Количество' | 'Номенклатура'    | 'Ед.' | 'Характеристика'   | 'Причина' | 'Серия'                        | 'В ед. хранения' | 'Цена'   | 'Цена с учетом скидок' | '% НДС' | 'Сумма'     | 'Сумма НДС' | 'Всего'     |
		| '3' | '-10,000'    | 'Сыр Костромской' | 'кг'  | '<Без маркировки>' | ''        | '000001 до 27.10.2020 0:00:00' | '-10,000, кг'    | '100,00' | '100,00'               | '18%'   | '-1 000,00' | '-152,54'   | '-1 000,00' |
	И в таблице "Расхождения" из выпадающего списка "Причина" я выбираю по строке 'Изменились цена и количество в поступлен'
	И в таблице "Расхождения" я завершаю редактирование строки
	И в поле 'Комментарий' я ввожу текст 'Корректировка корректировки поступления товаров'
	И я нажимаю на кнопку 'Провести и закрыть'
	И я жду закрытия окна 'Корректировка поступления товаров (создание) *' в течение 20 секунд
	Тогда открылось окно 'Корректировки поступлений товаров'
	И я закрываю окно 'Корректировки поступлений товаров'

Сценарий: 009.4. Purchase. Завершение

	И я закрываю сеанс TESTCLIENT